public_html/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::group([], function()
{
    Route::get('/register', 'Auth\RegisterController@showRegistrationForm')->name('register');
    Route::post('/register', 'Auth\RegisterController@register')->name('register');
    Route::get('/login', 'Auth\LoginController@login')->name('login');
    Route::post('/checkLogin', 'Auth\LoginController@checkLogin')->name('login.check');
    Route::get('/logout', 'Auth\LoginController@logout')->name('logout');


    Route::get('/', 'securityDashboardController@index')->name('dashboard');
    Route::get('/getDataCounts', 'securityDashboardController@getData')->name('data.counts');


    Route::group([
        'as' => 'anomalies.',
        'prefix' => 'anomalies-dashboard'
    ], function() {
        Route::get('/', 'anomaliesAnalysisController@index')->name('index');
    });

    Route::group([
        'as' => 'notifications.',
        'prefix' => 'notifications'
    ], function() {
        Route::get('/', 'notificationsController@index')->name('index');
        Route::get('/index/dt', 'notificationsController@ajaxNotificationsTable')->name('index.dt');
        Route::get('/reload/index/dt', 'notificationsController@ajaxReloadNotificationsTable')->name('reload.index.dt');
        Route::get('/checkNew', 'notificationsController@ajaxCheckNewNotifications')->name('checkNew');
    });



});


Route::group([
    'as' => 'data-trace.',
    'prefix' => 'data-trace'
], function() {
    // Route::redirect('/', '/data-trace/requests', 301);
    Route::get( '/{path?}', 'dataTraceController@index')->where('path', '.*')->name('index');
});

Route::group([
    'as' => 'service-topology.',
    'prefix' => 'servicetopology'
], function(){
    Route::get('/', 'serviceTopologyController@index')->name('index');
});

Route::group([
    'as' => 'security-pipeline.',
    'prefix' => 'security-pipeline'
], function(){
    Route::post('/algorithm-parameter', 'securityPipelineController@getAlgorithmParameter')->name('algorithm-parameter');
    Route::post('/update-config-param', 'securityPipelineController@updateResourceConfig')->name('update-config-param');
    Route::get('/', 'securityPipelineController@index')->name('index');
    Route::get('/index/dt', 'securityPipelineController@datatables')->name('index.dt');
    Route::get('/create/', 'securityPipelineController@create')->name('create');
    Route::post('/store/', 'securityPipelineController@store')->name('store');
    Route::get('/{securityPipeline}/edit', 'securityPipelineController@edit')->name('edit');
    Route::post('/agent-parameter', 'securityPipelineController@getAgentParameter')->name('agent-parameter');
    Route::post('/status', 'securityPipelineController@updatePipelineStatus')->name('status');
    Route::get('/status/get', 'securityPipelineController@getPipelineStatus')->name('status.get');
    Route::post('/{securityPipeline}', 'securityPipelineController@update')->name('update');
    Route::delete('/{securityPipeline}', 'securityPipelineController@destroy')->name('destroy');
    Route::get('/{securityPipeline}/reload', 'securityPipelineController@reloadPipelineInstance')->name('reloadPipelineInstance');

    Route::get('/add-config-panel', 'securityPipelineController@addConfigPanel')->name('add-config-panel');
});

Route::group([
    'as' => 'users.',
    'prefix' => 'users'
], function(){
    Route::get('/index/dt', 'UserController@datatables')->name('profile.index.dt');
    Route::get('list/', 'UserController@index')->name('index');
    Route::get('profile/', 'UserController@profile')->name('profile');
    Route::get('setting/', 'UserController@setting')->name('setting');
    Route::post('/{user}/profile', 'UserController@update')->name('update');
    Route::post('/{user}/setting', 'UserController@updateSetting')->name('updateSetting');
    Route::get('users/', 'UserController@userList')->name('users');
    Route::delete('/{user}', 'UserController@destroy')->name('destroy');
    Route::post('/update-status', 'UserController@updateStatus')->name('update-status');
    Route::post('/update-role', 'UserController@updateRole')->name('update-role');
});

public_html/resources/views/security-pipeline/partials/js/agent-parameters-scripts.blade.php
<script>
    $(function() {
        $('[data-toggle="tooltip"]').tooltip();

        $(".expand-params").on('click', function () {
            $(this).find('.rotate-icon').toggleClass('fa-chevron-up fa-chevron-down');
            $(this).find('.rotate-icon').toggleClass('text-guard-dark text-white');
        });

        $(".expand-source").on('click', function () {
            $(this).find('.rotate-icon').toggleClass('fa-chevron-up fa-chevron-down');
            $(this).find('.rotate-icon').toggleClass('text-guard-dark text-white');
        });

        $(".reloadButton").on('click', function(e) {

            e.stopPropagation();
            let Agentinstance = $(this).attr("id");
            let instance = $(this).attr("data-content");
            let instanceData = JSON.parse($('#instance-'+Agentinstance).val());

            if(Array.isArray(instanceData) && instanceData.length) {
                let instanceInputId =  $('#collapse-'+instance);
                $.each(instanceData, function(key, value){
                    let inputID = "text_param_"+value['id'];
                    let inputType = instanceInputId.find('#'+inputID).attr('type');

                    if(inputType === 'checkbox') {
                        instanceInputId.find('#'+inputID).prop('checked', value['value']['old']);
                    } else {
                        instanceInputId.find('#'+inputID).val(value['value']['old']);
                    }

                });

                $('#heading-'+instance).after('<div class="col-12 bg-primary-300 text-left my-2 py-2 border border-grey reload-msg" role="tab">Instance reloaded default configuration successfully</div>')
                $('.reload-msg').delay(3000).fadeOut("slow");
            }
        });
    });

    /**
     * This function is used the download the resource content
     *
     * @param $this
     */
    function getResourceTextDownload($this){
        let filename = $this+'.yml';
        let text = $('#content_'+$this).val();
        let element = document.createElement('a');

        element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(text));
        element.setAttribute('download', filename);
        element.style.display = 'none';
        document.body.appendChild(element);
        element.click();
        document.body.removeChild(element);
    }
</script>

public_html/resources/views/security-pipeline/partials/js/algorithm-parameters-scripts.blade.php
<script>
    $(function() {
        $('[data-toggle="tooltip"]').tooltip();

        $(".algo-expand-params").on('click', function () {
            $(this).find('.rotate-icon').toggleClass('fa-chevron-up fa-chevron-down');
            $(this).find('.rotate-icon').toggleClass('text-guard-dark text-white');
        });

        $(".algo-expand-source").on('click', function () {
            $(this).find('.rotate-icon').toggleClass('fa-chevron-up fa-chevron-down');
            $(this).find('.rotate-icon').toggleClass('text-guard-dark text-white');
        });

    });

    /**
     * This function is used the download the resource content
     *
     * @param $this
     */
    function getResourceTextDownload($this){
        let filename = $this+'.yml';
        let text = $('#content_'+$this).val();
        let element = document.createElement('a');

        element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(text));
        element.setAttribute('download', filename);
        element.style.display = 'none';
        document.body.appendChild(element);
        element.click();
        document.body.removeChild(element);
    }
</script>

public_html/resources/views/security-pipeline/partials/js/create-edit-scripts.blade.php
<script src="{!! asset('js/parsley.min.js') !!}"></script>
<script type="text/javascript">
    let selected;
    let agents = JSON.parse({!! json_encode($agentsJson) !!});
    let algorithms = {!! json_encode($algorithms) !!};
    let pipelineId = $('#pipelineId').val();
    $('.form-check-input-styled').uniform();
    $.ajaxSetup({
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        }
    });

    $(function () {
        let form = $('#smart-dashboard-form');
        form.parsley();

        // tooltip
        $('[data-toggle="tooltip"]').tooltip();

        let agentInfoLines = $('.agent_info');
        let agentId = $('input[type="radio"]:checked').attr('id');
        let pipelineFormRow = $('#pipelineFormTable tbody tr');
        let algoPipelineFormRow = $('#algoPipelineFormTable tbody tr');

        let selectedAgent = $('#agent_'+cleanedjQueryString(agentId));
        let preSelectedAgentEnv = $('#agent_env_'+cleanedjQueryString(agentId));
        let  selectedInstanceArr = [];
        let i = 0;

        let algoSelectedInstanceArr = [];
        let algorithmId = $('input[name="algorithm_id"]:checked').attr('id');
        let selectedAlgorithm = $('#algorithm_'+cleanedjQueryString(algorithmId));
        let preSelectedAlgorithmEnv = $('#algorithm_env_'+cleanedjQueryString(algorithmId));
        let algorithmInfoLines = $('.algorithm_info');

        // add selected class on agent and env rows on load
        agentInfoLines.hide();
        selectedAgent.addClass("agent-selected");
        preSelectedAgentEnv.addClass('agent-env-selected');

        algorithmInfoLines.hide();
        selectedAlgorithm.addClass("algorithm-selected");
        preSelectedAlgorithmEnv.addClass('algorithm-env-selected');

        // get parameters of the selected agent when page loads
        $('input[name="environment_id[]"]:checked').each(function() {
            selectedInstanceArr[i++] = {
                'instanceId': this.value,
                'instanceParam': $('#instance-'+cleanedjQueryString(agentId)+'-'+cleanedjQueryString(this.value)).val(),
            }
        });

        getAgentParameters(agentId, agents, pipelineId, selectedInstanceArr);

        preSelectedAgentEnv.show();

        $("input[name='agent_id']").click(function(){
            agentId = $(this).attr('id');
            let selectedAgent = $('#agent_env_'+cleanedjQueryString(agentId));
            // removing and adding selected class on agent and env rows on click
            pipelineFormRow.removeClass('agent-selected');
            $(this).closest("tbody tr").addClass("agent-selected");
            selectedAgent.addClass('agent-env-selected');

            //unselect any checkbox
            $('input[name="environment_id[]"]:checked').prop('checked',false).uniform('refresh');
            // get parameters of the selected agent

            getAgentParameters(agentId, agents);
            agentInfoLines.hide();
            selectedAgent.slideDown();
        });

        $('input[name="environment_id[]"]').click(function(){
            selectedInstanceArr=[];
            i = 0;
            $('input[name="environment_id[]"]:checked').each(function() {
                selectedInstanceArr[i++] = {
                    'instanceId': this.value,
                    'instanceParam': $('#instance-'+cleanedjQueryString(agentId)+'-'+cleanedjQueryString(this.value)).val(),
                }
            });

            getAgentParameters(agentId, agents, pipelineId, selectedInstanceArr);

        });

        // get parameters of the selected algorithm when page loads
        let j = 0;
        $('input[name="algorithm_environment_id[]"]:checked').each(function() {
            algoSelectedInstanceArr[j++] = {
                'algoInstanceId': this.value,
                'algoInstanceParam': $('#instance-'+cleanedjQueryString(algorithmId)+'-'+cleanedjQueryString(this.value)).val(),
            }
        });

        getAlgorithmParameters(algorithmId, algorithms, pipelineId, algoSelectedInstanceArr);

        preSelectedAlgorithmEnv.show();

        $("input[name='algorithm_id']").click(function(){
            algorithmId = $(this).attr('id');

            let algorithmIdCleaned = cleanedjQueryString(algorithmId);
            let selectedAlgorithm = $("#"+"algorithm_env_"+algorithmIdCleaned);
            // removing and adding selected class on agent and env rows on click
            algoPipelineFormRow.removeClass('algorithm-selected');
            $(this).closest("tbody tr").addClass("algorithm-selected");
            selectedAlgorithm.addClass('algorithm-env-selected');
            //unselect any checkbox
            $('input[name="algorithm_environment_id[]"]:checked').prop('checked',false).uniform('refresh');
            // get parameters of the selected agent

            getAlgorithmParameters(algorithmId, algorithms);
            algorithmInfoLines.hide();
            selectedAlgorithm.slideDown();
        });

        $('input[name="algorithm_environment_id[]"]').click(function(){
            algoSelectedInstanceArr=[];
            j = 0;
            $('input[name="algorithm_environment_id[]"]:checked').each(function() {

                algoSelectedInstanceArr[j++] = {
                    'algoInstanceId': this.value,
                    'algoInstanceParam': $('#instance-'+cleanedjQueryString(algorithmId)+'-'+cleanedjQueryString(this.value)).val(),
                }
            });

            getAlgorithmParameters(algorithmId, algorithms, pipelineId, algoSelectedInstanceArr);
        });

    });

    /**
     * list parameters of agent when agent get selected on pipeline add/edit page
     *
     * @param $this
     * @param $agents
     * @param $pipelineId
     * @param $selectedInstanceArr
     */
    function getAgentParameters($this, $agents, $pipelineId, $selectedInstanceArr){
        $('.spinloading').html('<i class="fa fa-spinner fa-spin fa-3x fa-fw mx-auto"></i><span class="sr-only">Loading...</span>');

        $.ajax({
            type: "POST",
            url: '{!! route('security-pipeline.agent-parameter') !!}',
            data: {
                'agentId' : $this,
                'agents': $agents,
                'pipelineId': $pipelineId,
                'selectedInstanceArr': $selectedInstanceArr
            },
            success: function (data) {
                $('.spinloading').html('');
                if(data.status === 'success') {
                    $('#agentParameter').html(data.html);
                }
            }
        });
    }

    /**
     *
     * @param $this
     * @param $algorithms
     * @param $pipelineId
     * @param $algoSelectedInstanceArr
     */
    function getAlgorithmParameters($this, $algorithms, $pipelineId, $algoSelectedInstanceArr){
        $.ajax({
            type: "POST",
            url: '{!! route('security-pipeline.algorithm-parameter') !!}',
            data: {
                'algorithmId' : $this,
                'algorithms': $algorithms,
                'pipelineId': $pipelineId,
                'algoSelectedInstanceArr': $algoSelectedInstanceArr
            },
            success: function (data) {
                if(data.status === 'success') {
                    $('#algorithmParameter').html(data.html);
                }
            }
        });
    }

    function cleanedjQueryString(string){
        if(typeof string !== 'undefined'){
            return string.replaceAll(/[!"#$%&'()*+,\/;<=>?@[\\\]^`{|}~]/g, "\\$&");
        }else{
            return string;
        }
    }

</script>

public_html/resources/views/security-pipeline/partials/js/update-status-scripts.blade.php
<script type="text/javascript">

    let selected;
    $('.form-check-input-styled').uniform();

    // update pipeline status
    function updatePipelineStatus(status, pipelineId){

        updateStatusLabel(status, pipelineId);
        $.ajax({
            type: "POST",
            url: '{!! route('security-pipeline.status') !!}',
            data: {
                'status' : status,
                'pipelineId': pipelineId,
            },

        })
        .done(function(data){
            if(data.status === 'success') {
                let updatedStatus = data.updatedStatus;
                updateStatusLabel(updatedStatus, pipelineId);

                new PNotify({
                    title: updatedStatus.charAt(0).toUpperCase() + updatedStatus.slice(1),
                    text: 'Pipeline '+updatedStatus+' successfully',
                    addclass: 'bg-success-600 border-success-800',
                    delay: 3000,
                    closer: true,
                });

            }else if(data.status === 'failed') {
                if(data.updatedStatus === 'stop'){
                    updateStatusLabel('started', pipelineId);
                }else if(data.updatedStatus === 'start'){
                    updateStatusLabel('stopped', pipelineId);
                }
                new PNotify({
                    title: 'Start/stop',
                    text: 'Action was unsuccessful. Try again. If the issue persists, please contact support.',
                    addclass: 'bg-danger-600 border-danger-800',
                    delay: 3000,
                    closer: true,
                });
            }
            return true;
        })
        .fail(function(data){
            new PNotify({
                title: 'Start/stop',
                text: 'Action was unsuccessful. Try again. If the issue persists, please contact support.',
                addclass: 'bg-danger-600 border-danger-800',
                delay: 3000,
                closer: true,
            });
        });
    }

    function updateStatusLabel(status, pipelineId){

        let pipeLineElementId = $('#'+pipelineId);
        let actionButton = $('.pipeline-start-stop-btn');

        //Starting, Stopping
        if(status === 'start') {
            pipeLineElementId.addClass('badge-light');
            pipeLineElementId.removeClass('badge-primary');
            pipeLineElementId.text('Starting');
            //action btn
            actionButton.text('Starting');
            actionButton.attr('disabled', true);
        }else if(status === 'stop'){
            pipeLineElementId.addClass('badge-light');
            pipeLineElementId.removeClass('badge-primary');
            pipeLineElementId.text('Stopping');
            actionButton.attr('disabled', true);
        }else if(status === 'started'){
            if(pipeLineElementId.hasClass('badge-danger')){
                pipeLineElementId.removeClass('badge-danger');
            }
            if(pipeLineElementId.hasClass('badge-light')){
                pipeLineElementId.removeClass('badge-light');
            }
            pipeLineElementId.addClass('badge-primary');
            pipeLineElementId.text('Started');
            //action btn
            actionButton.attr('disabled', false);
            actionButton.text('Stop');
            if(actionButton.hasClass('btn-primary')) {
                actionButton.removeClass('btn-primary');
            }
            actionButton.addClass('btn-danger');
        }else if(status === 'stopped'){
            if(pipeLineElementId.hasClass('badge-primary')){
                pipeLineElementId.removeClass('badge-primary');
            }
            if(pipeLineElementId.hasClass('badge-light')){
                pipeLineElementId.removeClass('badge-light');
            }
            pipeLineElementId.addClass('badge-danger');
            pipeLineElementId.text('Stopped');
            //action btn
            actionButton.attr('disabled', false);
            actionButton.text('Start');
            if(actionButton.hasClass('btn-danger')) {
                actionButton.removeClass('btn-danger');
            }
            actionButton.addClass('btn-primary');
        }
    }

</script>